<?php
/*****************************************************************************
 Tag Cloud
 
 Developer	: Miles Johnson
 Email		: mileswjohnson@gmail.com
 Website	: http://www.mileswjohnson.com/
 Last Edit	: January 4th 2007
 
******************************************************************************
 
 ABOUT:
 
 Creates a tag cloud with tags taken from a database. Tags are then given
 a unique number for how many tags are unique, and then a font size is chosen.
 
 READ ME:
 
 You must initiate your own database, and be sure to change the query below 
 to match your table and column.

 Within my tag system, tags are inserted into a varchar column, and seperated
 by a comma and a space, as so: miles, johnson, designer, tag, cloud
 
 For the explode to work properly, you must also do it this way, or change the
 explode to match however you enter your tags into your database.
 
******************************************************************************/

// Create the tag function
function getTags($minFont=10, $maxFont=35) {
	$tags  = array();
	$cloud = array();
	
	// Grab the tags from the database
	$query = mysql_query("SELECT tags FROM news ORDER BY RAND()");
	
	while($t = mysql_fetch_array($query)) {
		$db = explode(', ', $t[0]);
		
    	while(list($key, $value) = each($db)){
       		$tags[$value] += 1;
    	}
	}
	
	// Get totals to use for font size
	$min = min(array_values($tags));
	$max = max(array_values($tags));
	$fix = ($max - $min == 0) ? 1 : $max - $min;

	// Display the tags
	foreach ($tags as $tag => $count) {
		$size = $minFont + ($count - $min) * ($maxFont - $minFont) / $fix;
		$cloud[] = '<a style="font-size: '. floor($size) .'px" class="cloud" href="#" title="Tag: '. ucfirst($tag) .' was used '. $count .' times!">'. htmlspecialchars(stripslashes(ucfirst($tag))) . '</a>';
	}

	$shown = join("\n", $cloud) . "\n";
	return $shown;
} ?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-us" lang="en-us">
<head>
<title>(( Miles Johnson )) Tag Cloud</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<style type="text/css">
	#cloud { padding: 0px 15px; }
	.cloud { padding: 3px; text-decoration: none; line-height: 60%; }
	.cloud:link { color: #94B3C5; }
	.cloud:active { color: #94B3C5; }
	.cloud:visited { color: #B5B4A0; }
	.cloud:hover { color: #ffffff; background: #091a1a; }
	.cloud:focus { color: #ffffff; background: #93C644; }
</style>
</head>

<body>
<div id="cloud">
	<?php echo getTags(10, 30); ?>
</div>
</body>
</html>