<?php
/**
 * Application Tempate V1.0
 * Database Abstraction Layer (using procedural style for mysqli on PHP5)
 * Handling connection and executing SQL Statement to selected database
 * @version 7.0
 * @update September 02 2005
 */
class dbAbstract
{
	var $_db_linkid;
	var $_db_qresult;
	var $_auto_commit;
	var $RowData;
	var $NextRowNumber;
	var $RowCount;
	var $row;
	var $Affected;
    function dbAbstract ()
    {
    	$this->_db_linkid = 0;
    	$this->_db_qresult = 0;
    	$this->_auto_commit = false;
    	$this->RowData = array();
    	$this->NextRowNumber = 0;
    	$this->RowCount = 0;
		DIE ("DBAL :: Do not create instances of dbAbstract! Use a subclass.");
	}
	function Open ($host, $user, $pass, $db = "", $autocommit = true)
	{
	}
	function Close ()
	{
	}
	function SelectDB ($dbname)
	{
	}
	function Query ($querystr)
	{
	}
	function SeekRow ($row = 0)
	{
	}
	function ReadRow ()
	{
	}
	function Commit ()
	{
	}
	function RollBack ()
	{
	}
	function SetAutoCommit ($autocommit)
	{
		$this->_auto_commit = $autocommit;
    }
	function _ident ()
	{
		return "DBAL :: Ver. 2.0.0";
	}
};
// New MySQLi db call
class dbMySQL extends dbAbstract
{
	function dbMySql ($host, $user, $pass, $db = "")
	{
		$this->Open ($host, $user, $pass, $db);
		if($db != "") $this->SelectDB($db);
	}
	function Open ($host, $user, $pass, $db, $autocommit = true)
	{
		if (!$this->_db_linkid = @mysqli_connect ($host, $user, $pass, $db)) DIE ("Connecting to DB Server is failed. <br>Because of: ". mysqli_connect_error());
	}
	function Close ()
	{
		if ($this->_db_linkid)
		{
			@mysqli_free_result($this->_db_qresult);
			return mysqli_close ($this->_db_linkid);
		}
	}
	function SelectDB ($dbname)
	{
		if (!@mysqli_select_db ($this->_db_linkid, $dbname)) DIE ("Connection to DB Server is established, but we can't found the selected database \"<b>$dbname</b>\"");
	}
	function LastId()
	{
		return mysqli_insert_id($this->_db_linkid);
	}
	function getrow()
	{
		$this->row=@mysqli_fetch_array($this->_db_qresult,MYSQL_ASSOC);
		return $this->row;
	}
	function FirstRow()
	{
		$result=@mysqli_data_seek($this->_db_qresult,0);
		if ($result)
		{
			$result=$this->getrow();
			return $this->row;
		}
		else return 0;
	}
	function Query ($querystr, $debug=0)
	{
		if (!$result = @mysqli_query ($this->_db_linkid, $querystr)) DIE ("Wrong SQL Statement: <font color=#FF0000><b>".$querystr."</b></font><br>Mysql Comment:".mysqli_error($this->_db_linkid));
        else
		{
			if ($this->_db_qresult) @mysqli_free_result ($this->_db_qresult);
			$this->Affected = mysqli_affected_rows($this->_db_linkid);
			$this->RowData = array();
			$this->_db_qresult = $result;
			$this->RowCount = @mysqli_num_rows ($this->_db_qresult);
			if (!$this->RowCount) $this->RowCount = 0;
			return 1;
		}
	}
	function SeekRow ($row = 0)
	{
		if ( (!mysqli_data_seek ($this->_db_qresult, $row)) or ($row > $this->RowCount-1) )
		{
			printf ("DBAL :: MySQLi : Can not seek to row %d\n", $row);
			return 0;
		}
		else return 1;
	}
	function ReadRow ()
	{
		if ($this->RowData = mysqli_fetch_array ($this->_db_qresult,MYSQL_ASSOC))
		{
			$this->NextRowNumber++;
			return 1;
		}
		else return 0;
	}
	function Commit ()
	{
		return 1;
	}
	function RollBack ()
	{
		print "DBAL :: MySQLi : Rollback is not yet supported by MySQL Database Engine";
	}
	function _ident ()
	{
		return "DBAL :: MySQLi Database Engine : Ver. 3.1.0";
	}
};
?>